
#include "GSMP.h"
#include "SXmlDoc.h"

//package head
CGSMPHead::CGSMPHead()
{
	nTotalLength = 0;
	nCommandId = 0;
	nSequence = 0;
	nVersion = 10;
}

CGSMPHead::~CGSMPHead()
{

}

void CGSMPHead::Replace(CGSMPHead *pHead)
{
	nTotalLength = pHead->nTotalLength;
	nCommandId = pHead->nCommandId;
	nSequence = pHead->nSequence;
	nVersion = pHead->nVersion;
}

//login package
CGSMPLogin::CGSMPLogin()
{
	m_sUser = "";
	m_sPassword = "";
	m_sLoginType = "";
}

CGSMPLogin::~CGSMPLogin()
{

}

int CGSMPLogin::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("User", (char *)m_sUser.c_str());
	pXml->InsertItem("Password", (char *)m_sPassword.c_str());
	pXml->InsertItem("LoginType", (char *)m_sLoginType.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPLogin::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	cout << "BEFORE:" << pBuf << endl;
	pXml->Parse(pBuf);
	cout << "AFTER:" << endl;
	pXml->Print();

	char cTmp[2048];
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("User", cTmp);
	this->m_sUser = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("Password", cTmp);
	this->m_sPassword = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("LoginType", cTmp);
	this->m_sLoginType = cTmp;

	delete pXml;

	return 0;
}

void CGSMPLogin::Replace(CGSMPLogin *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sUser = pMsg->m_sUser;
	m_sPassword = pMsg->m_sPassword;
	m_sLoginType = pMsg->m_sLoginType;
}

//submit resp

CGSMPSubmitResp::CGSMPSubmitResp()
{
	m_sMsgid = "";
	m_sResult = "";
	m_nRecvTime = 0;
}

CGSMPSubmitResp::~CGSMPSubmitResp()
{

}

void CGSMPSubmitResp::Replace(CGSMPSubmitResp *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sMsgid = pMsg->m_sMsgid;
	m_sResult = pMsg->m_sResult;
	m_nRecvTime = pMsg->m_nRecvTime;
}

int CGSMPSubmitResp::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("Msgid", (char *)m_sMsgid.c_str());
	pXml->InsertItem("Result", (char *)m_sResult.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPSubmitResp::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	pXml->Parse(pBuf);

	char cTmp[1024];
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("Msgid", cTmp);
	this->m_sMsgid = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("Result", cTmp);
	this->m_sResult = cTmp;

	delete pXml;

	return 0;
}

//login,deliver,report resp
CGSMPResp::CGSMPResp()
{
	m_sResult = "";

	m_nRecvTime = 0;
}

CGSMPResp::~CGSMPResp()
{

}

void CGSMPResp::Replace(CGSMPResp *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sResult = pMsg->m_sResult;
	m_nRecvTime = pMsg->m_nRecvTime;
}

int CGSMPResp::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("Result", (char *)m_sResult.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPResp::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	pXml->Parse(pBuf);

	char cTmp[1024];
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("Result", cTmp);
	this->m_sResult = cTmp;

	delete pXml;

	return 0;
}

CGSMPSubmit::CGSMPSubmit()
{
	m_sMsgType = "";//Ϣ
	m_sMsgId = "";//Ϣк
	m_sSrcGWId = "";//ԴCPرʶ
	m_sDestGWId = "";//ĿOPرʶ
	m_sSrcTermId = "";//Դ
	m_sChargeTermId = "";//ƷѺ
	m_sChargeTermType = "";//ƷѺͣ0-ʵֻ 1-α
	m_sDestTermCount = "";//ĿֻĿǰ֧50
	m_sDestTermId = "";//Ŀֻ룬֮Զŷָ
	m_sDestTermType = "";//Ŀֻͣ0-ʵֻ 1-α
	m_sServiceId = "";//ҵ
	m_sFeeType = "";//Ʒ
	m_sFeeCode = "";//ƷѴ
	m_sGivenValue = "";//	ͨûΪͻ,СͨûΪⶥ,λΪ
	m_sMTF = "";//MTԭ:
	m_sMsgLevel = "";//ȼ
	m_sValidTime = "";//Чʱ
	m_sAtTime = "";//Ϣʱ͵ʱ䣬Ϊգʾ̷͸öϢ
	m_sNeedReport = "";//ǷҪ״̬ 
	m_sTPpid = "";//GSMЭ͡ϸǽοGSM03.40е9.2.3.9
	m_sTPudhi = "";//GSMЭ͡ϸǽοGSM03.40е9.2.3.23
	m_sMsgFmt = "";//Ϣıʽ
	m_sMsgContType = "";//ͣ0ı1ҪBASE64
	m_sMsgCont = "";//Ϣ
	m_sLinkId = "";//㲥MTļȨϢ
}

CGSMPSubmit::~CGSMPSubmit()
{

}

void CGSMPSubmit::Replace(CGSMPSubmit *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sMsgType = pMsg->m_sMsgType;//Ϣ
	m_sMsgId = pMsg->m_sMsgId;//Ϣк
	m_sSrcGWId = pMsg->m_sSrcGWId;//ԴCPرʶ
	m_sDestGWId = pMsg->m_sDestGWId;//ĿOPرʶ
	m_sSrcTermId = pMsg->m_sSrcTermId;//Դ
	m_sChargeTermId = pMsg->m_sChargeTermId;//ƷѺ
	m_sChargeTermType = pMsg->m_sChargeTermType;//ƷѺͣ0-ʵֻ 1-α
	m_sDestTermCount = pMsg->m_sDestTermCount;//ĿֻĿǰ֧50
	m_sDestTermId = pMsg->m_sDestTermId;//Ŀֻ룬֮Զŷָ
	m_sDestTermType = pMsg->m_sDestTermType;//Ŀֻͣ0-ʵֻ 1-α
	m_sServiceId = pMsg->m_sServiceId;//ҵ
	m_sFeeType = pMsg->m_sFeeType;//Ʒ
	m_sFeeCode = pMsg->m_sFeeCode;//ƷѴ
	m_sGivenValue = pMsg->m_sGivenValue;//	ͨûΪͻ,СͨûΪⶥ,λΪ
	m_sMTF = pMsg->m_sMTF;//MTԭ:
	m_sMsgLevel = pMsg->m_sMsgLevel;//ȼ
	m_sValidTime = pMsg->m_sValidTime;//Чʱ
	m_sAtTime = pMsg->m_sAtTime;//Ϣʱ͵ʱ䣬Ϊգʾ̷͸öϢ
	m_sNeedReport = pMsg->m_sNeedReport;//ǷҪ״̬ 
	m_sTPpid = pMsg->m_sTPpid;//GSMЭ͡ϸǽοGSM03.40е9.2.3.9
	m_sTPudhi = pMsg->m_sTPudhi;//GSMЭ͡ϸǽοGSM03.40е9.2.3.23
	m_sMsgFmt = pMsg->m_sMsgFmt;//Ϣıʽ
	m_sMsgContType = pMsg->m_sMsgContType;//ͣ0ı1ҪBASE64
	m_sMsgCont = pMsg->m_sMsgCont;//Ϣ
	m_sLinkId = pMsg->m_sLinkId;//㲥MTļȨϢ
}


int CGSMPSubmit::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("MsgType", (char *)m_sMsgType.c_str());
	pXml->InsertItem("MsgId", (char *)m_sMsgId.c_str());
	pXml->InsertItem("SrcGWId", (char *)m_sSrcGWId.c_str());
	pXml->InsertItem("DestGWId", (char *)m_sDestGWId.c_str());
	pXml->InsertItem("SrcTermId", (char *)m_sSrcTermId.c_str());
	pXml->InsertItem("ChargeTermId", (char *)m_sChargeTermId.c_str());
	pXml->InsertItem("ChargeTermType", (char *)m_sChargeTermType.c_str());
	pXml->InsertItem("DestTermCount", (char *)m_sDestTermCount.c_str());
	pXml->InsertItem("DestTermId", (char *)m_sDestTermId.c_str());
	pXml->InsertItem("DestTermType", (char *)m_sDestTermType.c_str());
	pXml->InsertItem("ServiceId", (char *)m_sServiceId.c_str());
	pXml->InsertItem("FeeType", (char *)m_sFeeType.c_str());
	pXml->InsertItem("FeeCode", (char *)m_sFeeCode.c_str());
	pXml->InsertItem("GivenValue", (char *)m_sGivenValue.c_str());
	pXml->InsertItem("MTF", (char *)m_sMTF.c_str());
	pXml->InsertItem("MsgLevel", (char *)m_sMsgLevel.c_str());
	pXml->InsertItem("ValidTime", (char *)m_sValidTime.c_str());
	pXml->InsertItem("AtTime", (char *)m_sAtTime.c_str());
	pXml->InsertItem("NeedReport", (char *)m_sNeedReport.c_str());
	pXml->InsertItem("TPpid", (char *)m_sTPpid.c_str());
	pXml->InsertItem("TPudhi", (char *)m_sTPudhi.c_str());
	pXml->InsertItem("MsgFmt", (char *)m_sMsgFmt.c_str());
	pXml->InsertItem("MsgContType", (char *)m_sMsgContType.c_str());
	pXml->InsertItem("MsgCont", (char *)m_sMsgCont.c_str());
	pXml->InsertItem("LinkId", (char *)m_sLinkId.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPSubmit::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	pXml->Parse(pBuf);
cout << "======RECV:=====" << endl << pBuf << endl;
//pXml->Print();

	char cTmp[1024];
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgType", (char *)cTmp);
	this->m_sMsgType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgId", (char *)cTmp);
	this->m_sMsgId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SrcGWId", (char *)cTmp);
	this->m_sSrcGWId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestGWId", (char *)cTmp);
	this->m_sDestGWId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SrcTermId", (char *)cTmp);
	this->m_sSrcTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("ChargeTermId", (char *)cTmp);
	this->m_sChargeTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("ChargeTermType", (char *)cTmp);
	this->m_sChargeTermType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestTermCount", (char *)cTmp);
	this->m_sDestTermCount = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestTermId", (char *)cTmp);
	this->m_sDestTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestTermType", (char *)cTmp);
	this->m_sDestTermType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("ServiceId", (char *)cTmp);
	this->m_sServiceId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("FeeType", (char *)cTmp);
	this->m_sFeeType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("FeeCode", (char *)cTmp);
	this->m_sFeeCode = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("GivenValue", (char *)cTmp);
	this->m_sGivenValue = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MTF", (char *)cTmp);
	this->m_sMTF = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgLevel", (char *)cTmp);
	this->m_sMsgLevel = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("ValidTime", (char *)cTmp);
	this->m_sValidTime = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("AtTime", (char *)cTmp);
	this->m_sAtTime = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("NeedReport", (char *)cTmp);
	this->m_sNeedReport = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("TPpid", (char *)cTmp);
	this->m_sTPpid = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("TPudhi", (char *)cTmp);
	this->m_sTPudhi = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgFmt", (char *)cTmp);
	this->m_sMsgFmt = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgContType", (char *)cTmp);
	this->m_sMsgContType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgCont", (char *)cTmp);
	this->m_sMsgCont = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("LinkId", (char *)cTmp);
	this->m_sLinkId = cTmp;

	delete pXml;

	return 0;
}

CGSMPDeliver::CGSMPDeliver()
{
	m_sMsgType = "";//Ϣ
	m_sMsgId = "";//	
	m_sSrcGWId = "";//ԴOPرʶ
	m_sDestGWId = "";//ĿCPرʶ
	m_sSrcTermId = "";//Դֻ
	m_sSrcTermType = "";//Դֻͣ0-ʵֻ 1-α
	m_sDestTermId = "";//Ŀĺ.
	m_sServiceId = "";//ҵ
	m_sMsgLevel = "";//	ȼ
	m_sMsgFmt = "";//Ϣıʽ
	m_sMsgContType = "";//ͣ0ı1ҪBASE64
	m_sMsgCont = "";//	Ϣ
	m_sLinkId = "";//㲥MTļȨϢ, 	
}

CGSMPDeliver::~CGSMPDeliver()
{

}

void CGSMPDeliver::Replace(CGSMPDeliver *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sMsgType = pMsg->m_sMsgType;//Ϣ
	m_sMsgId = pMsg->m_sMsgId;//	
	m_sSrcGWId = pMsg->m_sSrcGWId;//ԴOPرʶ
	m_sDestGWId = pMsg->m_sDestGWId;//ĿCPرʶ
	m_sSrcTermId = pMsg->m_sSrcTermId;//Դֻ
	m_sSrcTermType = pMsg->m_sSrcTermType;//Դֻͣ0-ʵֻ 1-α
	m_sDestTermId = pMsg->m_sDestTermId;//Ŀĺ.
	m_sServiceId = pMsg->m_sServiceId;//ҵ
	m_sMsgLevel = pMsg->m_sMsgLevel;//	ȼ
	m_sMsgFmt = pMsg->m_sMsgFmt;//Ϣıʽ
	m_sMsgContType = pMsg->m_sMsgContType;//ͣ0ı1ҪBASE64
	m_sMsgCont = pMsg->m_sMsgCont;//	Ϣ
	m_sLinkId = pMsg->m_sLinkId;//㲥MTļȨϢ, 
}

int CGSMPDeliver::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("MsgType", (char *)m_sMsgType.c_str());
	pXml->InsertItem("MsgId", (char *)m_sMsgId.c_str());
	pXml->InsertItem("SrcGWId", (char *)m_sSrcGWId.c_str());
	pXml->InsertItem("DestGWId", (char *)m_sDestGWId.c_str());
	pXml->InsertItem("SrcTermId", (char *)m_sSrcTermId.c_str());
	pXml->InsertItem("SrcTermType", (char *)m_sSrcTermType.c_str());
	pXml->InsertItem("DestTermId", (char *)m_sDestTermId.c_str());
	pXml->InsertItem("ServiceId", (char *)m_sServiceId.c_str());
	pXml->InsertItem("MsgLevel", (char *)m_sMsgLevel.c_str());
	pXml->InsertItem("MsgFmt", (char *)m_sMsgFmt.c_str());
	pXml->InsertItem("MsgContType", (char *)m_sMsgContType.c_str());
	pXml->InsertItem("MsgCont", (char *)m_sMsgCont.c_str());
	pXml->InsertItem("LinkId", (char *)m_sLinkId.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPDeliver::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	pXml->Parse(pBuf);

	char cTmp[1024];
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgType", (char *)cTmp);
	this->m_sMsgType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgId", (char *)cTmp);
	this->m_sMsgId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SrcGWId", (char *)cTmp);
	this->m_sSrcGWId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestGWId", (char *)cTmp);
	this->m_sDestGWId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SrcTermId", (char *)cTmp);
	this->m_sSrcTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SrcTermType", (char *)cTmp);
	this->m_sSrcTermType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestTermId", (char *)cTmp);
	this->m_sDestTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("ServiceId", (char *)cTmp);
	this->m_sServiceId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgLevel", (char *)cTmp);
	this->m_sMsgLevel = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgFmt", (char *)cTmp);
	this->m_sMsgFmt = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgContType", (char *)cTmp);
	this->m_sMsgContType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgCont", (char *)cTmp);
	this->m_sMsgCont = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("LinkId", (char *)cTmp);
	this->m_sLinkId = cTmp;

	delete pXml;

	return 0;
}

CGSMPReport::CGSMPReport()
{
	m_sMsgType = "";//Ϣ
	m_sMsgId = "";//״̬汾Ϣ
	m_sSubmitMsgId = "";//״̬漰SubmitϢ
	m_sDestTermId = "";//Ŀֻ
	m_sStat = "";//ݸֶȷSubmitϢ״̬
	m_sSubmitTime = "";//ύʱ,YYMMDDHHMMYYΪĺλ00-99MM01-12DD01-31HH00-23MM00-59
	m_sDoneTime = "";//ʱ, YYMMDDHHMM
}

CGSMPReport::~CGSMPReport()
{

}

void CGSMPReport::Replace(CGSMPReport *pMsg)
{
	m_Head.Replace(&pMsg->m_Head);
	m_sMsgType = pMsg->m_sMsgType;//Ϣ
	m_sMsgId = pMsg->m_sMsgId;//״̬汾Ϣ
	m_sSubmitMsgId = pMsg->m_sSubmitMsgId;//״̬漰SubmitϢ
	m_sDestTermId = pMsg->m_sDestTermId;//Ŀֻ
	m_sStat = pMsg->m_sStat;//ݸֶȷSubmitϢ״̬
	m_sSubmitTime = pMsg->m_sSubmitTime;//ύʱ,YYMMDDHHMMYYΪĺλ00-99MM01-12DD01-31HH00-23MM00-59
	m_sDoneTime = pMsg->m_sDoneTime;//ʱ, YYMMDDHHMM
	
}

int CGSMPReport::OutXmlBuf(char *pBuf, int *pLen)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc("msg");//new CSXmlDoc("msg");
	pXml->InsertItem("MsgType", (char *)m_sMsgType.c_str());
	pXml->InsertItem("MsgId", (char *)m_sMsgId.c_str());
	pXml->InsertItem("SubmitMsgId", (char *)m_sSubmitMsgId.c_str());
	pXml->InsertItem("DestTermId", (char *)m_sDestTermId.c_str());
	pXml->InsertItem("Stat", (char *)m_sStat.c_str());
	pXml->InsertItem("SubmitTime", (char *)m_sSubmitTime.c_str());
	pXml->InsertItem("DoneTime", (char *)m_sDoneTime.c_str());

	pXml->GetXmlChar(pBuf);

	delete pXml;
	
	return 0;

}

int CGSMPReport::InXmlBuf(char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CSXmlDoc *pXml = new CSXmlDoc();//new CSXmlDoc("msg");
	pXml->Parse(pBuf);

	char cTmp[2000]; //modified by LJQ ,from 1024 to 2000
	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgType", (char *)cTmp);
	this->m_sMsgType = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("MsgId", (char *)cTmp);
	this->m_sMsgId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SubmitMsgId", (char *)cTmp);
	this->m_sSubmitMsgId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DestTermId", (char *)cTmp);
	this->m_sDestTermId = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("Stat", (char *)cTmp);
	this->m_sStat = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("SubmitTime", (char *)cTmp);
	this->m_sSubmitTime = cTmp;

	memset(cTmp, 0, sizeof(cTmp));
	pXml->GetItemByName("DoneTime", (char *)cTmp);
	this->m_sDoneTime = cTmp;

	delete pXml;

	return 0;
}


