// SockBase.cpp: implementation of the CSockBase class.
//
//////////////////////////////////////////////////////////////////////
#include "SockBase.h"
extern const int END_SUCCEED;
extern const int END_FAILED;
#ifdef WIN32
#include <iostream>
#include <fstream>
using namespace std;
#endif
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CSockBase::CSockBase()
{
#ifdef LINUX
	pthread_mutex_init(&m_socketbase_send_mutex, NULL);
	pthread_mutex_init(&m_socketbase_recv_mutex, NULL);
#endif
}
CSockBase::~CSockBase()
{
}
bool CSockBase::SendToDest(int nSockfd, const char *pBuf, int nLen)
 {
/*
cout << "send len: " << nLen << endl;
char *ppp = (char *)pBuf;
for (int a=0; a<nLen; a++)
{
	printf("0x%02x ", *ppp);	
	ppp++;
	if ((a+1)%4 == 0)
		cout << endl;
}
cout << endl;
*/
 	if (nSockfd <= 0)
 		return false;
 		
 	int nSendLen = 0;
	const char *p = pBuf;
	int nLeftLen = nLen;
#ifdef LINUX
	//pthread_mutex_lock(&m_socketbase_send_mutex);
#endif
#ifdef WIN32
	//m_socketbase_send_mutex.Lock();
#endif
	
 	for (; nLeftLen > 0; nLeftLen -= nSendLen)
 	{
 		p += nSendLen;
 		nSendLen = send(nSockfd, (const char *)p, nLeftLen, 0);
 		if (nSendLen < 0)
 		{
#ifdef WIN32
 			if (errno == WSAEINTR)
#endif
#ifdef LINUX
			if (errno == EINTR)
#endif
 				nSendLen = 0;
 			else
			{
#ifdef LINUX
				//pthread_mutex_unlock(&m_socketbase_send_mutex);
#endif
#ifdef WIN32
				//m_socketbase_send_mutex.Unlock();
#endif
 				return false;
			}
 		} 		
 	} 
#ifdef LINUX
	//pthread_mutex_unlock(&m_socketbase_send_mutex);
#endif
#ifdef WIN32
	//m_socketbase_send_mutex.Unlock();
#endif
	if (nLeftLen == 0)
 		return true;
	else 
		return false;
 }
 
int CSockBase::RecvFromDest(int nSockfd, char *pBuf, int *pLen, int nTimeout)
{
	int        i_read = 0 ;
	int        i_len = 0;
	int			nBufLen = *pLen;
	*pLen = 0;
	if(nSockfd < 0)
	{    
		return END_FAILED ;
	}
#ifdef LINUX
	//pthread_mutex_lock(&m_socketbase_recv_mutex);
#endif
#ifdef WIN32
	//m_socketbase_recv_mutex.Lock();
#endif
    /*
    ** read file length 
    */
	i_read = tcp_recv(nSockfd, pBuf, 4, nTimeout);
    if ( i_read == -1 )
    {
#ifdef LINUX
		//pthread_mutex_unlock(&m_socketbase_recv_mutex);
#endif
#ifdef WIN32
		//m_socketbase_recv_mutex.Unlock();
#endif
        return(END_FAILED);
    }
	//added by liaomch 2003-10-17
	//ʱյΪ0
    if ( i_read == 0)
    {
#ifdef LINUX
		//pthread_mutex_unlock(&m_socketbase_recv_mutex);
#endif
#ifdef WIN32
		//m_socketbase_recv_mutex.Unlock();
#endif
        return (-2);//TIMEOUT
    }
	//end added by liaomch
	
	int nTemp = 0;
	memcpy(&nTemp, pBuf, sizeof(int));
	i_len = ntohl(nTemp);  
	if (i_len > nBufLen)
	{
#ifdef LINUX
		//pthread_mutex_unlock(&m_socketbase_recv_mutex);
#endif
#ifdef WIN32
		//m_socketbase_recv_mutex.Unlock();
#endif
		return( END_FAILED );
		//return -3;//Ҫյ̫
	}
    i_read = tcp_recv(nSockfd, pBuf+4, i_len-4, nTimeout);
#ifdef LINUX
	//pthread_mutex_unlock(&m_socketbase_recv_mutex);
#endif
#ifdef WIN32
	//m_socketbase_recv_mutex.Unlock();
#endif
    if ( i_read == -1 )
    {
        return( END_FAILED );
    }
	//added by liaomch 2003-10-17
	//ʱյΪ0
    if ( i_read == 0)
    {
		//pthread_mutex_unlock(&m_recv_mutex);
        return (-2);//TIMEOUT
    }
	//end added by liaomch
    if ( i_read + 4 != i_len )
    {
		printf("===received a bad package!===\n"
			"\tmust recv = %d, real recv = %d\n", i_len, (i_read));
        return(END_FAILED);
    }
	*pLen = i_len;
/*
cout << "recv len: " << i_len << endl;
char *ppp = (char *)pBuf;
for (int a=0; a<i_len; a++)
{
        printf("0x%02x ", *ppp);
        ppp++;
        if ((a+1)%4 == 0)
                cout << endl;
}
cout << endl;
*/
    return (END_SUCCEED);
}
int CSockBase::tcp_recv(int nSockfd, char *pBuf, int nLen, int nTimeOut)
{
	char   *ps_buf = pBuf;
	int    l_read_so_far = 0;
	int    l_read = 0;
	int    l_len = 0;
	if (nSockfd < 0)
		return END_FAILED;
	//time_t tStartRead = time(NULL);
	//time out set
	fd_set	rset;
	struct timeval	tval;
	
	memset(&tval, 0, sizeof(tval));
	
	if( nTimeOut < 0 )
		nTimeOut=0;
	
	FD_ZERO(&rset);
	FD_SET(nSockfd,&rset);
	
	tval.tv_sec = nTimeOut;
	tval.tv_usec = 0 ;
	//-------------
	
	while ( l_read_so_far < nLen ) 
	{
		ps_buf += l_read_so_far;
		l_len = nLen - l_read_so_far;
#ifdef LINUX
		int nSelRet = 0;
		if (nTimeOut == 0)
			nSelRet = select(nSockfd+1,&rset,NULL,NULL,NULL);
		else
			nSelRet = select(nSockfd+1,&rset,NULL,NULL,&tval);
		if(nSelRet == 0 )
		{
			printf("recv time out return!\n");
			return	0;//time out
		}
#endif
#ifdef WIN32
		int nBytesCanBeRead=0;
		time_t tStart = time(NULL);
		while (nBytesCanBeRead <= 0)
		{
			int nIoRet = ioctlsocket(nSockfd, FIONREAD, (DWORD*)&nBytesCanBeRead);
			if(nIoRet != 0)
				return END_FAILED;
			if ((time(NULL) - tStart) >= nTimeOut)
			{
				return 0;//time out
			}
			Sleep(2);
		}
#endif
		//printf("---> Byte Can be Read: %d\n", nBytesCanBeRead);
		l_read = recv(nSockfd, ps_buf, l_len, 0);
#ifdef WIN32
		int nErr = WSAGetLastError();
#endif
		//read returns by itself (not because of timed out)
		if ( l_read <= 0 ) 
		{
#ifdef WIN32
			int nErr = WSAGetLastError();
			printf("read error! errno = %d\n", nErr);
			if (errno == WSAEINTR)
#endif
#ifdef LINUX
			if (errno == EINTR)
#endif
			{
 				l_read = 0;
				return END_FAILED;
			}
 			else
 				return END_FAILED;
		} 
		else  if ( l_read > 0 ) 
		{
			l_read_so_far += l_read;
		}
    }
    return( l_read_so_far );
} 
 
 int CSockBase::ConnectTimeOut(int sockfd, const struct sockaddr *saptr, socklen_t socklen, int secs)
{
	int	flags;
	int	n,error;
	socklen_t	len;
	fd_set	rset,wset;
	struct timeval	tval;
	if(sockfd <= 0 || saptr == (struct sockaddr *)0)
		return	END_FAILED;
	if( secs < 0 )
		secs=0;
	error=0;
	
#ifdef LINUX
	flags=fcntl(sockfd,F_GETFL,0);
	fcntl(sockfd,F_SETFL,flags|O_NONBLOCK);
#endif
#ifdef WIN32
	flags = 1L;//no blocking
	ioctlsocket(sockfd, FIONBIO, (u_long *)&flags);
#endif
	if((n=connect(sockfd,saptr,socklen)) < 0 )
    {
#ifdef WIN32
	    if(errno != WSAEINPROGRESS)
#endif
#ifdef LINUX
		if(errno != EINPROGRESS)
#endif
        { 
			return(END_FAILED);
        }
    }
	if(n == 0 )
		goto	done;
	FD_ZERO(&rset);
	FD_SET(sockfd,&rset);
	wset =rset;
	tval.tv_sec = secs;
	tval.tv_usec = 0 ;
	if(( n=select(sockfd+1,&rset,&wset,NULL,secs?&tval:NULL)) == 0 )
	{
		close(sockfd);
#ifdef WIN32
		errno = WSAETIMEDOUT;
#endif
#ifdef LINUX
		errno = ETIMEDOUT;
#endif
		return	END_FAILED;
	}
	
	if(FD_ISSET(sockfd,&rset) || FD_ISSET(sockfd,&wset)) 
	{
		len=sizeof(error);
		if( getsockopt(sockfd,SOL_SOCKET,SO_ERROR, (char *)&error, (socklen_t *)&len) < 0 )
			return	END_FAILED;
	}
	else
		return	END_FAILED;
done:
#ifdef LINUX
	fcntl(sockfd,F_SETFL,flags);
#endif
#ifdef WIN32
	ioctlsocket(sockfd,FIONBIO,(u_long *)&flags);
#endif
	
	if(error)
	{
		close(sockfd);
		errno=error;
		return	END_FAILED;
	}
	return	END_SUCCEED;
}
//********************************************************************
//	TcpConnect
//		Build up a TCP connection to host at port.  This is used at
//		client part, returns the socket fd on success, or -1 on error
//********************************************************************
int CSockBase::TcpConnect(char* host, int port)
{
	int fd;
	struct sockaddr_in sin;
	if((fd=socket(AF_INET, SOCK_STREAM, 0))<0)
	{
		return END_FAILED;
	}	
	// resolv host to sockaddr_in
	memset(&sin, 0, sizeof(sin));
	
	//try A.B.C.D numeric IP format address first
	if((sin.sin_addr.s_addr=inet_addr(host))==INADDR_NONE)
	{
		//not numeric IP format, try text format
		struct hostent he;
		//int err, ret;
		//here we use **_r format, 'coz it might be run under multithreading
		//environment.
		//However, some such functions are not standardized yet, so we need
		//know OS platform we are on.
		#ifdef LINUX_
		//struct hostent *gethostbyname(const char *name);
		//LINUX: gethostbyname_r needs six parameters 
		//it return 0 on success, otherwise -1 returned, and 
		//the error code is in err:
		// ERANGE:	buf size too small
		// HOST_NOT_FOUND: Authoritive Answer Host not found
		// TRY_AGAIN:	Non-Authoritive Host not found, or SERVERFAIL
		// NO_RECOVERY: Non recoverable errors, FORMERR, REFUSED, NOTIMP
		// NO_DATA:	    Valid name, no data record of requested type
		// NO_ADDRESS:  no address, look for MX record
		if ((ret=gethostbyname_r(host, &he, buf, sizeof(buf), &p, &err)) < 0 )
		{
			close(fd);
			return END_FAILED; //Resolve failed! :(
		}	
		#elif defined LINUX
		struct hostent *pHost = NULL;
		if ((pHost = gethostbyname(host)) == NULL)
		{
			close(fd);
			return END_FAILED; //Resolve failed! :(
		}
		memset(&he, 0, sizeof(struct hostent));
		memcpy(&he, pHost, sizeof(struct hostent));
		#elif defined SOLARIS
		//NOTE: be sure to link libnsl.o while compiling
		//     that is, use -lnsl in gcc command options
		//SOLARIS: gethostbyname_r takes five parameters, 
		//it returns the pointer to he in p on success, otherwise NULL
		//the error code is also in err, read above comments
		p=gethostbyname_r(host, &he, buf, sizeof(buf), &err);
		if(!p)
		{
			close(fd);
			return END_FAILED;
		}	
		#endif
		#ifdef WIN32
		struct hostent *p = gethostbyname((const char *)host);
		memset(&he, 0, sizeof(struct hostent));
		memcpy(&he, p, sizeof(struct hostent));
		//struct hostent* FAR gethostbyname(  const char* name );
		#endif
		memcpy(&sin.sin_addr.s_addr, he.h_addr, sizeof(sin.sin_addr.s_addr));
	}
	// here we assume we are always under IPv4 environment.
	// If one day shifted to other network environment, such as IPv6,
	// following code should also be under modification
	sin.sin_family=AF_INET;
	sin.sin_port=htons(port);
	//connect
	if(connect(fd, (struct sockaddr*)&sin, sizeof(sin))<0)
	{
		close(fd);
		return END_FAILED;
	}
	return fd;
}	
//********************************************************************
//  TcpConnecto:
//      Time out version.
//      Build up a TCP connection to host at port.  This is used at
//      client part, returns the socket fd on success, or -1 on error
//********************************************************************
int CSockBase::TcpConnectTimeOut(char* host, int port,int secs)
{
	int fd;
	struct sockaddr_in sin;
	if((fd=socket(AF_INET, SOCK_STREAM, 0))<0)
	{
		return END_FAILED;
	}	
	// resolv host to sockaddr_in
	memset(&sin, 0, sizeof(sin));
	
	//try A.B.C.D numeric IP format address first
	if((sin.sin_addr.s_addr=inet_addr(host))==INADDR_NONE)
	{
		//not numeric IP format, try text format
		//struct hostent he; 
		struct hostent he; 
		//int err, ret;
		//here we use **_r format, 'coz it might be run under multithreading
		//environment.
		//However, some such functions are not standardized yet, so we need
		//know OS platform we are on.
		#ifdef LINUX_		
		//LINUX: gethostbyname_r needs six parameters 
		//it return 0 on success, otherwise -1 returned, and 
		//the error code is in err:
		// ERANGE:	buf size too small
		// HOST_NOT_FOUND: Authoritive Answer Host not found
		// TRY_AGAIN:	Non-Authoritive Host not found, or SERVERFAIL
		// NO_RECOVERY: Non recoverable errors, FORMERR, REFUSED, NOTIMP
		// NO_DATA:	    Valid name, no data record of requested type
		// NO_ADDRESS:  no address, look for MX record
		if ((ret=gethostbyname_r(host, &he, buf, sizeof(buf), &p, &err)) < 0 )
		{
			 close(fd);
			 return END_FAILED; //Resolve failed! :(
		}
		#elif defined LINUX
		struct hostent *pHost = NULL;
		if ((pHost = gethostbyname(host)) == NULL)
		{
			close(fd);
			return END_FAILED; //Resolve failed! :(
		}
		memset(&he, 0, sizeof(struct hostent));
		memcpy(&he, pHost, sizeof(struct hostent));
		#elif defined SOLARIS
		//NOTE: be sure to link libnsl.o while compiling
		//     that is, use -lnsl in gcc command options
		//SOLARIS: gethostbyname_r takes five parameters, 
		//it returns the pointer to he in p on success, otherwise NULL
		//the error code is also in err, read above comments
		p=gethostbyname_r(host, &he, buf, sizeof(buf), &err);
		if(!p)
		{
            close(fd);
			return END_FAILED;
		}	
		#endif
		#ifdef WIN32
		struct hostent *p = gethostbyname((const char *)host);
		memset(&he, 0, sizeof(struct hostent));
		memcpy(&he, p, sizeof(struct hostent));
		//struct hostent* FAR gethostbyname(  const char* name );
		#endif
		memcpy(&sin.sin_addr.s_addr, he.h_addr, sizeof(sin.sin_addr.s_addr));
	}
	// here we assume we are always under IPv4 environment.
	// If one day shifted to other network environment, such as IPv6,
	// following code should also be under modification
	sin.sin_family=AF_INET;
	sin.sin_port=htons(port);
	//connect
	if (ConnectTimeOut(fd, (struct sockaddr*)&sin, sizeof(sin),secs)<0 )
	{
		close(fd);
		return END_FAILED;
	}
	return fd;
}
int CSockBase::CreateServer(int Iport)
{
#ifdef WIN32
	WSADATA wsaData;
	WORD version = MAKEWORD(2,0);
	int ret = WSAStartup(version, &wsaData);
	if (ret != 0)
		TRACE("Initilize Error!\n");
#endif
	int nSockfd = socket(AF_INET, SOCK_STREAM, 0);
	sockaddr_in  ServerAddr;
	if(nSockfd < 0)
	{
#ifdef WIN32
		int nError = WSAGetLastError();
		printf("Create Server Listen in Port:[%d] Error:[%d]!\n", Iport, nError);
		switch (nError)
		{
		case WSANOTINITIALISED:
			cout << "A successful WSAStartup must occur before using this function." << endl;
			break;
		case WSAENETDOWN:
			cout << "The network subsystem or the associated service provider has failed. " << endl;
			break;
		case WSAEAFNOSUPPORT:
			cout << "The specified address family is not supported. " << endl;
			break;
		case WSAEINPROGRESS:
			cout << "A blocking Windows Sockets 1.1 call is in progress, or the service provider is still processing a callback function. " << endl;
			break;
		case WSAEMFILE:
			cout << " No more socket descriptors are available. " << endl;
			break;
		case WSAENOBUFS:
			cout << " No buffer space is available. The socket cannot be created. " << endl;
			break;
		case WSAEPROTONOSUPPORT:
			cout << " The specified protocol is not supported. " << endl;
			break;
		case WSAEPROTOTYPE:
			cout << " The specified protocol is the wrong type for this socket. " << endl;
			break;
		case WSAESOCKTNOSUPPORT:
			cout << " The specified socket type is not supported in this address family. " << endl;
			break;
		default:
			cout << "Unknow error!" << endl;
		}
#endif
		
		return END_FAILED;
	}
	memset(&ServerAddr, 0, sizeof(ServerAddr));
	ServerAddr.sin_family = AF_INET;
	ServerAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	ServerAddr.sin_port = htons(Iport);
	int nOptVal = 1;
	setsockopt(nSockfd,SOL_SOCKET,SO_REUSEADDR, (const char *)&nOptVal,sizeof(nOptVal));
	if(bind(nSockfd, (sockaddr*)&ServerAddr, sizeof(ServerAddr)) < 0)
		return END_FAILED;
	if (m_iAcceptNum < 15)
		m_iAcceptNum = 15;
	
	if(listen(nSockfd, m_iAcceptNum) < 0)
		return END_FAILED;
	return nSockfd;
}
int CSockBase::GetAccept( int nSockfd )
{
	int  TempSock;
	if(nSockfd < 0)
		return END_FAILED;
	struct sockaddr_in client_addr;
	int nCliAddrLen = 0;
	nCliAddrLen = sizeof(client_addr);
	memset(&client_addr, 0, nCliAddrLen);
	TempSock = accept(nSockfd, (struct sockaddr *)&client_addr, (socklen_t *)&nCliAddrLen);
	if(TempSock < 0)
		return END_FAILED;
	else
	{
		printf("ACCEPT SUCCEED IPADDR:[%s]!\n", inet_ntoa(client_addr.sin_addr));
		return TempSock;
	}
 }
void CSockBase::turn_byte_order( unsigned char *ps_dest, unsigned char *ps_src, short t_len )
{
#ifdef SUN_CPU
    memcpy( ps_dest, ps_src, t_len);
#else
    while( t_len > 0 )
    {
        *ps_dest = *(ps_src + t_len -1 );
        ps_dest ++;
        t_len --;
    }
#endif
	return;
}

