/***********************************************************
 * XmlPaser.h
 * TinyXmlLib
 *
 *  ܣ 
 *  Author: 
 *
 *  
 *  Created on: 2009-10-8
 *  
 ***********************************************************/

#ifndef XMLPASER_H_
#define XMLPASER_H_
#include "tinyxml.h"
#include "tinystr.h"
#include  <vector>
using namespace std;

class Element {
	friend class XmlWriter;
	friend class XmlReader;
public:
	/**
	 * 췽
	 */
	Element(){}
	/**
	 * @pEleName:Ԫ
	 *
	 */
	Element(const char* pEleName) :
		m_xmlEle(pEleName) {
	}
	/**
	 * 캯
	 *
	 */
	Element(const Element& copy);
	/**
	 * ֵ
	 *
	 */
	Element& operator=(const Element& base);
public:
	/**
	 * ܣԪ
	 * @pAttrName
	 * @pAttrNameVal ԶӦֵ
	 *
	 */
	void SetAttribute(const char* pAttrName, const char* pAttrNameVal);
	/**
	 * ܣԪصı
	 *
	 * @pText:ı
	 * 磺
	 * <root>test</root>
	 * pTexttest
	 */
	void SetText(const char* pText);
	/**
	 * ܣ׷Ԫغ
	 *
	 * @child׷ӵԪ
	 */
	bool AppendChild(const Element& child);
	/**
	 * ܣȡԪصض
	 *
	 * @pAttrNameָ
	 *
	 * أֵ
	 *
	 */
	const char* GetAtrribute(const char* pAttrName);
	/**
	 * ܣȡԪı
	 *
	 * أԪı
	 *
	 */
	const char* GetText() const{return this->m_xmlEle.GetText();}
	/**
	 * ӡԪؼԪ
	 *
	 */
	void print();

	/**
	 * ܣȡԪ
	 *
	 */
	const char* GetValue() const {return m_xmlEle.Value();}

private:
	TiXmlElement m_xmlEle;
};
/**
 * xml
 *
 */
class XmlWriter {
public:
	//friend class Element;
	/**
	 * 캯
	 * @pRootName:Ԫ
	 *
	 */
	XmlWriter(const char* pRootName);
	/**
	 * 캯
	 *
	 * @pFileNamexmlļ
	 *
	 * @pRootName:Ԫ
	 */
	XmlWriter(const char* pFileName, const char* pRootName);
	virtual ~XmlWriter();
public:
	/**
	 * ܣxmlתַ
	 *
	 * أxmlʽַ
	 *
	 */
	virtual const char* ToXmlStr(char* pXmlBuf);
	virtual string ToXmlStr();
	/**
	 * :ӡxml
	 *
	 */
	virtual void PrintXml();
	/**
	 * :xml浽ļ
	 *
	 * @pFileNamexmlļ
	 * أtrue--ɹfalse--ʧ
	 *
	 */
	virtual bool SaveToFile(const char* pFileName = NULL);
	/**
	 * ܣ׷ӸԪصԪ
	 *
	 * @ElementҪӵԪأElementһ
	 *
	 * أִгɹtrueʧܷfalse
	 *
	 */
	virtual bool AppendElement(const Element* ele);
	/**
	 * ܣ浱ǰxmlĵ
	 *
	 */
	virtual void Save();

	virtual void SetEnCoding(const char* pEnCoding){m_szEnCoding=pEnCoding;}
private:
	virtual bool CreateEmptyXml();
	virtual void checkSaved();
private:
	TiXmlDocument* m_xmlDoc;
	TiXmlElement m_root;
	bool m_bIsSaved;
	string m_szEnCoding;
};

class XmlReader {
public:
	static const int FILE_READ_TYPE;
	static const int STRING_READ_TYPE;
public:
	XmlReader(const char* pFileName, int type = XmlReader::FILE_READ_TYPE);

	virtual ~XmlReader();
public:
	virtual bool Parse();
	virtual int GetFirstTextValue(const char* pElePath, char* pTxtVal);
	virtual int GetTextValue(const char* pElePath, char* pTxtVal,int nIndex=0);
	virtual int GetAttribute(const char* pElePath, const char* pAttrName,
			char* pAttrVal);
	virtual int GetElements(const char* pElePath,vector<Element*>& eles);
	virtual int GetSubElements(const char* pElePath,vector<Element*>& els);
	virtual int GetSubElements(const char* pElePath,vector<Element>& els);
	virtual int DestoryElements(vector<Element*>& eles);
	virtual int GetRootValue(char* pVal);
	virtual Element* GetRoot();
private:
	TiXmlElement* QuerySingleHandle(const char* pElePath,int nIndex);
private:
	TiXmlDocument* m_xmlDoc;
	int m_nXmlReadType;
	char* m_pName;
	//TiXmlHandle m_docHandle();
};



#endif /* XMLPASER_H_ */
